#include <bits/stdc++.h>
#define ll long long
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll n, m;
    cin >> n >> m;
    for(int i = 0; i < m; ++i){
        ll v, to;
        cin >> v >> to;
    }
    cout << "NO\n";
    return 0;
}
